% Simulation of level discrimination with multiple procedures. Code taken largely from
% Buus' simulation of gap detecion and MML.

% MMLog50
ntrials=50;
linlog='l';	%n=linear, l=log

%%%%% DOUBLE CHECK THESE VALUES
baseintensity=[30 90];
initintdiff=[6 3];	

percentagecatchtrials=0.20;

fa_list=[0 0.05 0.1 0.15 0.2];

initgapf=[30 90];
MDGf=[6 18];
slpf=[16 11];
critrng=[0.5 1];
critmid=1.64;
Nslst=ntrials;
mp=linspace(0,2.6,27);
a=linspace(0,0.4,5);
Gcatch=log10(0.5);
stdcrit=-invcumnorm(0.1);
Nruns=1000;
for baseintidx=1:2
   initint=initintdiff(baseintidx);
   MDG=log10(MDGf(baseintidx));
   slp=slpf(baseintidx);
   for fa=fa_list
      numcatchtrials=floor(ntrials*.20);
      numsignaltrials=ntrials-numcatchtrials;
      runnum=1;
      percentyes=zeros(27,5);
      %hold off
      while runnum<=Nruns
         G(1)=log10(initint);
         catchesthisrun=0;
         pr=zeros(27,5);
         rspvar=rand([1 ntrials]);
         catchvar=rand([1 ntrials]);
         thisfa_run=fa*2*rand([1 ntrials]);
         wr=0;
         for trial=1:ntrials
            thisfa=thisfa_run(trial);
%            fa(trial)=1-cumnorm(crit);
            if trial>1
               G(trial)=invlogis(0.6,slp,mp(ix(jx)),a(jx));
            end
            if (catchesthisrun<numcatchtrials)
               if catchvar(trial)<percentagecatchtrials
                  G(trial)=Gcatch;
                  catchesthisrun=catchesthisrun+1;
               end
               if (ntrials-trial)<=(numcatchtrials-catchesthisrun)
                  G(trial)=Gcatch;
                  catchesthisrun=catchesthisrun+1;
               end
            end
            dp=invcumnorm(logistic(G(trial),slp,MDG,0.1))+stdcrit;
            pyes=cumnorm(dp-crit);
            rsp(trial)=(rspvar(trial)<=pyes);
            for j=1:5
               py(:,j)=logistic(G(trial),slp,mp,a(j)).';
            end
            pr=pr+rsp(trial)*log(py)+(1-rsp(trial))*log(1-py);
            [px ix]=max(pr);
            [pxx jx]=max(px);
         end
         %	plot(ct);
         %	axis([0 Nt 0 2.5]);
         %	drawnow;
         %	shg;
         %	hold on;
         fax(nr)=mean(fa);
         pr=zeros(27,5);
         if jx>1
            sax=a(jx)-0.1;
         else
            sax=0;
         end
         mpx=linspace(mp(ix(jx))-0.13,mp(ix(jx))+0.13,27);
         ax=linspace(sax,sax+0.2,5);
         for trial=1:Nt
            for j=1:5
               py(:,j)=logistic(G(trial),slp,mpx,ax(j)).';
            end
            pr=pr+rsp(trial)*log(py)+(1-rsp(trial))*log(1-py);
            [px ix]=max(pr);
            [pxx jx]=max(px);
         end	
         if ax(jx)<=0.2
            Thr(nr)=mpx(ix(jx));
            falm(nr)=ax(jx);
            %		if mod(nr,500)==0
            %			disp([int2str(nr),' runs completed'])
            %		end
            nr=nr+1;
         else
            wr=wr+1;
            if mod(wr,100)==0
               warning(strcat(int2str(wr),' runs wasted'))
            end
         end
      end
      disp([Ns slp mean(fax) 10^MDG 10^mean(Thr) 10^std(Thr) mean(falm)])
   end
end
